package flyweight;

import java.awt.*;
import java.util.HashMap;
import java.util.Map;

public class BlockFactory {

    private static final Map<BlockCategory, BlockType> created = new HashMap<>();


    public static BlockType getBlockType(BlockCategory category) {
        if (created.containsKey(category)) {
            return created.get(category);
        }

        BlockType theBlockType = null;
        switch (category) {
            case FOREST:
                theBlockType = new BlockType(BlockCategory.FOREST, Color.YELLOW, "A wooded forest.");

                break;
            case OCEAN:
                theBlockType = new BlockType(BlockCategory.OCEAN, Color.CYAN, "A choppy ocean.");
                break;
            default:
                // normally we'd have cases for all of the BlockCategories, but there
                // are a lot of colors and hopefully you get the idea now.
                return null;
        }
        created.put(category, theBlockType);
        return theBlockType;

    }
}
